#include "FlightInformation.h"

#include "Announcer.h"

FlightInformation::FlightInformation()
: id(0)
{
}

int FlightInformation::subscribe(Announcer& subscriber)
{
    subscribers[++id] = &subscriber;
    return id;
}

void FlightInformation::unsubscribe(int id)
{
    SubscriptionCollection::iterator it = subscribers.find(id);

    if (it!=subscribers.end())
    {
        subscribers.erase(it);
    }
}

void FlightInformation::announce(const std::string& update)
{
    SubscriptionCollection::iterator it;

    for (it=subscribers.begin(); it!=subscribers.end(); ++it)
    {
        Announcer* announcer = it->second;

        if (announcer->isOperational())
        {
            announcer->display(update);
            //(*announcer)(update);
        }
    }
}
