#include <gtest/gtest.h>

class MyException : public std::exception
{
public:
	MyException(const char* message) : std::exception(message) {}
};

void methodThatThrows()
{
	throw MyException("Exception");
}

void methodThatDoesNotThrow()
{
}

TEST(ExceptionTest, ensureSpecificExceptionIsThrown)
{
	EXPECT_THROW(methodThatThrows(), MyException);
}

TEST(ExceptionTest, ensureExceptionThrownHasExectedBaseClass)
{
	EXPECT_THROW(methodThatThrows(), std::exception);
}

TEST(ExceptionTest, ensureSomeExceptionIsThrown)
{
	EXPECT_ANY_THROW(methodThatThrows());
}

TEST(ExceptionTest, ensureNoExceptionIsThrown)
{
	EXPECT_NO_THROW(methodThatDoesNotThrow());
}