#include <gtest/gtest.h>

template <typename T>
class TypedTests : public ::testing::Test
{
protected:
	T t;
	T t2;
};

class MyClass
{
public:
	operator int()
	{
		throw "Do not convert MyClass to int";
	}
};

typedef ::testing::Types<char, int, unsigned int, bool, MyClass> TypesToTest;
TYPED_TEST_CASE(TypedTests, TypesToTest);

TYPED_TEST(TypedTests, implicitlyConvertibleToInt) 
{
  EXPECT_NO_THROW(int i = this->t);
}

TYPED_TEST(TypedTests, operatorStarIsSymmetric) 
{
  EXPECT_NO_THROW(
	  EXPECT_EQ(t*t2, t2*t)
	  );
}

  // Inside a test, refer to the special name TypeParam to get the type
  // parameter.  Since we are inside a derived class template, C++ requires
  // us to visit the members of FooTest via 'this'.
  //e.g. TypeParam n = this->value_;

  // To visit static members of the fixture, add the 'TestFixture::'
  // prefix.
  // e.g. n += TestFixture::shared_;

  // To refer to typedefs in the fixture, add the 'typename TestFixture::'
  // prefix.  The 'typename' is required to satisfy the compiler.
  // typename TestFixture::List values;
  // values.push_back(n);
