#include <gtest/gtest.h>

const char HELLO_WORLD_LOWER_CASE[] = "hello world";
const char HELLO_WORLD_LOWER_CASE_2[] = "hello world";
const char HELLO_WORLD_UPPER_CASE[] = "HELLO WORLD";

const std::string helloWorld(HELLO_WORLD_LOWER_CASE);
const std::string helloWorld2(HELLO_WORLD_LOWER_CASE);
const std::string HelloWorld(HELLO_WORLD_UPPER_CASE);

TEST(StringComparison, comparingPointersShouldBehaveAsExpected)
{
	EXPECT_EQ(HELLO_WORLD_LOWER_CASE, HELLO_WORLD_LOWER_CASE);

	EXPECT_NE(HELLO_WORLD_LOWER_CASE, HELLO_WORLD_LOWER_CASE_2);
}

TEST(StringComparison, comparingNullTerminatedStringsShouldBehaveAsExpected)
{
	EXPECT_STREQ(HELLO_WORLD_LOWER_CASE, HELLO_WORLD_LOWER_CASE);

	EXPECT_STREQ(HELLO_WORLD_LOWER_CASE, HELLO_WORLD_LOWER_CASE_2);
}

TEST(StringComparison, comparingNullTerminatedStringsIgnoringCaseShouldBehaveAsExpected)
{
	EXPECT_STRCASEEQ(HELLO_WORLD_LOWER_CASE, HELLO_WORLD_UPPER_CASE);
}

TEST(StringComparison, comparingStdStringsShouldBehaveAsExpected)
{
	EXPECT_EQ(helloWorld, helloWorld);

	EXPECT_EQ(helloWorld, helloWorld2);

	EXPECT_NE(helloWorld, HelloWorld);

	EXPECT_NE(&helloWorld, &helloWorld2);

	EXPECT_STREQ(helloWorld.c_str(), helloWorld2.c_str());
}